#
#
# $Id: gtkboard.rb,v 1.21 2003/12/13 13:26:40 Yuukis Exp $
#
#

class SubjectFrame < Gtk::ScrolledWindow
	attr_reader :board, :past, :past_mode

	def initialize(board = false)
		@board = board
		@board = 'unix' if @board == false

		@thread_hash = {}  # åɤξ¤ΤǻĤΤɤ
		@bbs_board = LiveBBSBoard.new(@board)
		@vadj = Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)

		@past = board
		@pop = false
		@freeze = false  # not yet. 

		@clist = Gtk::CList.new(['', 'S', 'C', '', 'F', 'C', ' subject '])
		@clist.set_selection_mode(Gtk::SELECTION_BROWSE)
		@clist.set_usize(1, 1)
		@clist.add_vikey_events(@vadj)

		(0..6).each {|x| @clist.set_column_auto_resize(x, true) }
		(0..5).each {|x| @clist.set_column_justification(x, Gtk::JUSTIFY_RIGHT) }
		@clist.set_column_justification(6, Gtk::JUSTIFY_LEFT)
		(4..5).each {|x| @clist.set_column_min_width(x, 30) }

		right_menu_init


		@clist.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::GDK_a
				r = 0
				@clist.each_selection {|row| r = row }
				@bbs_board.bookmark.toggle(@thread_hash[@clist.get_text(r, 0)])
				coloring
			when Gdk::GDK_d
				r = 0
				@clist.each_selection {|row| r = row }
				@bbs_board.abone.toggle(@thread_hash[@clist.get_text(r, 0)])
				if @bbs_board.abone.include?(@thread_hash[@clist.get_text(r, 0)])
					@clist.remove_row(r)
				else
					coloring
				end
				@clist.select_row(r, 0)
			when Gdk::GDK_D
				if mode == 'past'
					r = 0
					@clist.each_selection {|row| r = row }
					@bbs_board.trash(@thread_hash[@clist.get_text(r, 0)])
					@clist.remove_row(r)
					@clist.select_row(r, 0)
				end
			when Gdk::GDK_equal then check('cache_plus')
			when Gdk::GDK_s then check('update')
			end
		}

		@clist.signal_connect('click_column') {|w, c|
			case c
			when 0 then refresh
			when 1 then check('update')
			when 3 then check('cache_plus')
			end
		}

		f, array = @bbs_board.get
		get(array) if f

		super(nil, @vadj)
		self.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_ALWAYS)
		self.add @clist
	end

	def switch(board)
		@past = @board
		@past_mode = mode
		@board = board
		@bbs_board = LiveBBSBoard.new(@board, @bbs_board.flags)
	end

	def refresh
		@bbs_board.flags.members.each {|x| @bbs_board.flags[x] = false }
		@bbs_board.flags.abone = true
		update(false)
	end

	def toggle  # live  past  toggle
		case mode
		when 'live' then @bbs_board = PastBBSBoard.new(@board, @bbs_board.flags)
		when 'past' then @bbs_board = LiveBBSBoard.new(@board, @bbs_board.flags)
		end
		f, array = @bbs_board.get
		if f
			get(array)
		else
			return(false)
		end
	end

	def mode
		case @bbs_board.class.to_s
		when 'LiveBBSBoard' then return('live')
		when 'PastBBSBoard' then return('past')
		end
	end

	def get(subjects_array)
		return(false) if @freeze
		@clist.freeze
		@clist.clear
		@thread_hash.clear
		n = 0
		subjects_array.each {|th|
			n += 1
			@clist.append([n.to_s, th[0], th[1], th[2], th[4], th[5], th[6].chomp])
			@thread_hash[n.to_s]= th[3]
		}
		coloring
		@clist.thaw
	end

	def update(get = true)
		f, array = @bbs_board.get(get)
		if f
			get(array)
		else
			return(false)
		end
	end

	def find(word)
		get(@bbs_board.get_find(word))
	end

	def rollback
		@bbs_board.rollback
	end

	def check(flag)
		if @bbs_board.flags[flag]
			@bbs_board.flags[flag] = false
		else
			@bbs_board.flags[flag] = true
		end
		update(false)
	end

	def cached(row)
		@clist.set_text(row, 2, 'C')
		@clist.set_text(row, 3, '=')
		@clist.set_text(row, 5, @clist.get_text(row, 4))

		#=> subject.txtʤĤ塢downloadĤΥ褦Ȥ
		begin
			begin
				@bbs_board.cached(@thread_hash[@clist.get_text(row, 0)], @board)
			rescue
				@bbs_board.cached(@thread_hash[@clist.get_text(row, 0)], @past)
			end
		rescue
			# Ǥʤ̵
		end
	end

	def coloring
		r = 0
		n = []

		@clist.freeze
		@clist.each_selection {|row|
			(0..6).each {|i| n << @clist.get_text(row, i)}
			@clist.insert(row+1, n)
			@clist.remove_row(row)
			@clist.select_row(row, 0)
		}
		@thread_hash.each {|n, d|
			if @bbs_board.abone.include?(d)
				@clist.set_background(n.to_i-1, CFG::GDK_Color.abone_bg)
			elsif @bbs_board.bookmark.include?(d)
				@clist.set_background(n.to_i-1, CFG::GDK_Color.bookmark_bg)
			end
		}
		@clist.thaw
	end
	private :coloring

	def child
		@clist
	end

	def hash
		@thread_hash
	end

	def filter
		@bbs_board.flags
	end

	def bookmark
		@bbs_board.bookmark
	end

	def abone
		@bbs_board.abone
	end

	def freeze
		@freeze = true
	end

	def thaw
		@freeze = false
	end

	def pop?
		if @pop
			@pop = false
			return(true)
		else
			return(false)
		end
	end

	def right_menu_init
		@clist.signal_connect('select_row') {|w, r, c, e|
			if e == nil
			elsif c == 0
				@pop = true
				menu = GtkExt::RightMenu.new(@clist.get_text(r, 6))
				@bbs_board.bookmark.update
				if @bbs_board.bookmark.include?(@thread_hash[@clist.get_text(r, 0)])
					menu.bookmark.child.set_text(CFG::NLS.srm_delete_bkmk)
				else
					menu.bookmark.child.set_text(CFG::NLS.srm_add_bkmk)
				end
				if @bbs_board.abone.include?(@thread_hash[@clist.get_text(r, 0)])
					menu.abone.child.set_text(CFG::NLS.srm_unset_abone)
				else
					menu.abone.child.set_text(CFG::NLS.srm_set_abone)
				end
				menu.title.signal_connect('activate') {
					menu.destroy
				}
				menu.bookmark.signal_connect('activate') {
					@bbs_board.bookmark.toggle(@thread_hash[@clist.get_text(r, 0)])
					coloring
					menu.destroy
				}
				menu.abone.signal_connect('activate') {
					@bbs_board.abone.toggle(@thread_hash[@clist.get_text(r, 0)])
					@clist.remove_row(r)
					menu.destroy
				}
				menu.popup(nil, nil, nil, e.button, e.time)
			end
		}
	end
	private :right_menu_init

end
